// ConfigDlg.cpp : t@C
//

#include "stdafx.h"
#include "string.h"
#include "BT62SettingSamp.h"
#include "ConfigDlg.h"


//
// combo box array
//
typedef struct {
	TCHAR	KeyString[32];
	ULONG	KeyValue;
	TCHAR	Settings[32];
	TCHAR	CmdString[32];
} COMBODEF, *PCOMBODEF;

// RS-232CgV[o
// ۏ؃{[[gMin.115.2kbps / Typ.230.4kbps
// 荂Ȑݒ͂łȂ悤ɂ
COMBODEF Baud[] = {
	{ " 1200", 1200, "1200", "SU,12\r\n" },
	{ " 2400", 2400, "2400", "SU,24\r\n" },
	{ " 4800", 4800, "4800", "SU,48\r\n" },
	{ " 9600", 9600, "9600", "SU,96\r\n" },
	{ " 19200", 19200, "19.2", "SU,19\r\n" },
	{ " 28800", 28800, "28.8", "SU,28\r\n" },
	{ " 38400", 38400, "38.4", "SU,38\r\n" },
	{ " 57600", 57600, "57.6", "SU,57\r\n" },
	{ " 115200", 115200, "115K", "SU,11\r\n" },
	{ " 230400", 230400, "230K", "SU,23\r\n" },
	//{ " 460800", 460800, "460K", "SU,46\r\n" },
	//{ " 921600", 921600, "921K", "SU,92\r\n" },
};

COMBODEF DataBit[] = {
	{ " 7", 7, " 7", "S7,1\r\n" },
	{ " 8", 8, " 8", "S7,0\r\n" },
};

COMBODEF Parity[] = {
	{ " None", NOPARITY, "None", "SL,N\r\n" },
	{ " Odd", ODDPARITY, "Odd ", "SL,O\r\n" },
	{ " Even", EVENPARITY, "Even", "SL,E\r\n" },
};

COMBODEF StopBit[] = {
	{ " 1", 1, " 1", "SQ,0\r\n" },
	{ " 2", 2, " 2", "SQ,256\r\n" },
};

// Ver 1.1.0.0 ǉ
COMBODEF Authen[] = {
	{ " F؂Ȃ", 1, "F Ȃ", "SA,0\r\n" },
	{ " SSPF", 2, "SSPF", "SA,1\r\n" },
	{ " PINF", 3, "PINF", "SA,4\r\n" },
};

// Ver 1.3.0.0 ǉ
COMBODEF HIDCrLf[] = {
	{ " CR:Enter / LF:Enter", 1, "CR:Enter / LF:Enter", "SO,0\r\n" },
	{ " CR:Enter / LF:Ȃ", 2, "CR:Enter / LF:Ȃ", "SO,1\r\n" },
	{ " CR:Ȃ / LF:Enter", 3, "CR:Ȃ / LF:Enter", "SO,2\r\n" },
	{ " CR:Ȃ / LF:Ȃ", 4, "CR:Ȃ / LF:Ȃ", "SO,3\r\n" },
};




// CConfigDlg _CAO

IMPLEMENT_DYNAMIC(CConfigDlg, CDialog)

CConfigDlg::CConfigDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConfigDlg::IDD, pParent)
	, m_BaudIndex(3)
	, m_DataIndex(1)
	, m_ParityIndex(0)
	, m_StopIndex(0)
	, m_StrBtName(_T(""))
	, m_HIDPushTimeIndex(0)
	, m_HIDCrLfIndex(0)
{
	theApp.m_CmdItemCount = 0;
	memset(theApp.m_CmdItemString[0], 0x0, sizeof(theApp.m_CmdItemString[0])*MAX_CMDNUM);
	//TRACE("CConfigDlg sizeof(theApp.m_CmdItemString[0]) = %d\n", sizeof(theApp.m_CmdItemString[0]));
}

CConfigDlg::~CConfigDlg()
{
}

void CConfigDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO2, m_CmbBaud);
	DDX_Control(pDX, IDC_COMBO3, m_CmbData);
	DDX_Control(pDX, IDC_COMBO4, m_CmbParity);
	DDX_Control(pDX, IDC_COMBO5, m_CmbStop);
	DDX_CBIndex(pDX, IDC_COMBO2, m_BaudIndex);
	DDX_CBIndex(pDX, IDC_COMBO3, m_DataIndex);
	DDX_CBIndex(pDX, IDC_COMBO4, m_ParityIndex);
	DDX_CBIndex(pDX, IDC_COMBO5, m_StopIndex);
	DDX_Control(pDX, IDC_CHECK2, m_ChkBtName);
	DDX_Control(pDX, IDC_EDIT10, m_EdtBtName);
	DDX_Text(pDX, IDC_EDIT10, m_StrBtName);
	DDX_Control(pDX, IDC_COMBO6, m_CmbAuth);
	DDX_CBIndex(pDX, IDC_COMBO6, m_AuthIndex);
	DDX_Control(pDX, IDC_STATIC12, m_StcAuth);
	DDX_Control(pDX, IDC_EDIT11, m_EdtPINCode);
	DDX_Control(pDX, IDC_STATIC11, m_StcPINCode);
	DDX_Text(pDX, IDC_EDIT11, m_StrPINCode);
	DDV_MaxChars(pDX, m_StrBtName, 20);
	DDV_MaxChars(pDX, m_StrPINCode, 16);
	DDX_Control(pDX, IDC_STATIC14, m_StcHIDPushTime);
	DDX_Control(pDX, IDC_STATIC15, m_StcHIDCrLf);
	DDX_Control(pDX, IDC_COMBO14, m_CmbHIDPushTime);
	DDX_CBIndex(pDX, IDC_COMBO14, m_HIDPushTimeIndex);
	DDX_Control(pDX, IDC_COMBO15, m_CmbHIDCrLf);
	DDX_CBIndex(pDX, IDC_COMBO15, m_HIDCrLfIndex);
}


BEGIN_MESSAGE_MAP(CConfigDlg, CDialog)
	ON_BN_CLICKED(IDC_CONFIG, &CConfigDlg::OnBnClickedConfig)
	ON_BN_CLICKED(IDC_DEFAULT, &CConfigDlg::OnBnClickedDefault)
	ON_BN_CLICKED(IDC_CHECK2, &CConfigDlg::OnBnClickedCheck2)
	ON_CBN_SELCHANGE(IDC_COMBO6, &CConfigDlg::OnCbnSelchangeCombo6)
END_MESSAGE_MAP()


// CConfigDlg bZ[W nh


// ================================================================
//e
// _CAO
//
//	Ȃ
//߂l
// TRUE
// ================================================================
BOOL CConfigDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ɏǉĂ
    int	i;
	int	cmbNum;
	CString strData;

	fDefault = FALSE;

	cmbNum = sizeof Baud /sizeof Baud[0];
	for (i = 0; i < cmbNum; i++)
    {
		if(_strnicmp(Baud[i].KeyString+1, theApp.m_StrBaud, theApp.m_StrBaud.GetLength()-2 ) == 0)
		{
			m_BaudIndex = i;
			TRACE("OnInitDialog m_BaudIndex = %d\n", m_BaudIndex);
		}
		m_CmbBaud.InsertString(i, (LPCTSTR)Baud[i].KeyString);
    }

	cmbNum = sizeof DataBit /sizeof DataBit[0];
	for (i = 0; i < cmbNum; i++)
    {
		if(_strnicmp(DataBit[i].Settings, theApp.m_StrData, 2 ) == 0)
		{
			m_DataIndex = i;
			TRACE("OnInitDialog m_DataIndex = %d\n", m_DataIndex);
		}
		m_CmbData.InsertString(i, (LPCTSTR)DataBit[i].KeyString);
    }
	if(_strnicmp(theApp.m_StrVersion, "Ver 4.77", 8 ) != 0)
	{
		m_CmbData.EnableWindow( FALSE );
	}

	if(_strnicmp(theApp.m_StrVersion, "BT62", 4 ) == 0)
	{
		m_CmbData.EnableWindow( TRUE );
	}

	cmbNum = sizeof Parity /sizeof Parity[0];
	for (i = 0; i < cmbNum; i++)
    {
		if(_strnicmp(Parity[i].Settings, theApp.m_StrParity, 4 ) == 0)
		{
			m_ParityIndex = i;
			TRACE("OnInitDialog m_ParityIndex = %d\n", m_ParityIndex);
		}
		m_CmbParity.InsertString(i, (LPCTSTR)Parity[i].KeyString);
    }

	cmbNum = sizeof StopBit /sizeof StopBit[0];
	for (i = 0; i < cmbNum; i++)
    {
		if(_strnicmp(StopBit[i].Settings, theApp.m_StrStop, 2 ) == 0)
		{
			m_StopIndex = i;
			TRACE("OnInitDialog m_StopIndex = %d\n", m_StopIndex);
		}
		m_CmbStop.InsertString(i, (LPCTSTR)StopBit[i].KeyString);
    }

	// Ver 1.2.0.0 "BT62 Ver."ȍ~̊mFĔFؕ
	if( _strnicmp( theApp.m_StrVersion.Mid( 9 ), "1.00", 4 ) == 0 )
	{
		m_CmbAuth.ShowWindow( SW_HIDE );
		m_StcAuth.ShowWindow( SW_HIDE );

		m_EdtPINCode.ShowWindow( SW_HIDE );
		m_StcPINCode.ShowWindow( SW_HIDE );

		// Ver 1.3.0.0 HID[h
		m_StcHIDPushTime.ShowWindow( SW_HIDE );
		m_StcHIDCrLf.ShowWindow( SW_HIDE );
		m_CmbHIDPushTime.ShowWindow( SW_HIDE );
		m_CmbHIDCrLf.ShowWindow( SW_HIDE );

	}
	else if( _strnicmp( theApp.m_StrVersion.Mid( 9 ), "1.01", 4 ) == 0 )
	{
		m_CmbAuth.ShowWindow( SW_HIDE );
		m_StcAuth.ShowWindow( SW_HIDE );

		m_EdtPINCode.ShowWindow( SW_HIDE );
		m_StcPINCode.ShowWindow( SW_HIDE );

		// Ver 1.3.0.0 HID[h
		m_StcHIDPushTime.ShowWindow( SW_HIDE );
		m_StcHIDCrLf.ShowWindow( SW_HIDE );
		m_CmbHIDPushTime.ShowWindow( SW_HIDE );
		m_CmbHIDCrLf.ShowWindow( SW_HIDE );
	}
	else
	{
		m_CmbAuth.ShowWindow( SW_SHOW );
		m_StcAuth.ShowWindow( SW_SHOW );

		// Ver 1.1.0.0 ǉ
		cmbNum = sizeof Authen /sizeof Authen[0];
		for (i = 0; i < cmbNum; i++)
		{
			if(_strnicmp(Authen[i].Settings, theApp.m_StrAuth, 5 ) == 0)
			{
				m_AuthIndex = i;
				TRACE("OnInitDialog m_AuthIndex = %d\n", m_AuthIndex);

				if( m_AuthIndex == 2 )
				{
					m_EdtPINCode.ShowWindow( SW_SHOW );
					m_StcPINCode.ShowWindow( SW_SHOW );
				}
				else
				{
					m_EdtPINCode.ShowWindow( SW_HIDE );
					m_StcPINCode.ShowWindow( SW_HIDE );
				}

				m_StrPINCode = theApp.m_StrPINCode;
			}
			m_CmbAuth.InsertString(i, (LPCTSTR)Authen[i].KeyString);
		}
	
		// Ver 1.3.0.0 HID[h
		if( _strnicmp( theApp.m_StrVersion.Mid( 9 ), "1.02", 4 ) == 0 )
		{
			m_StcHIDPushTime.ShowWindow( SW_HIDE );
			m_StcHIDCrLf.ShowWindow( SW_HIDE );
			m_CmbHIDPushTime.ShowWindow( SW_HIDE );
			m_CmbHIDCrLf.ShowWindow( SW_HIDE );
		}
		else if( _strnicmp( theApp.m_StrVersion.Mid( 9 ), "1.03", 4 ) == 0 )
		{
			m_StcHIDPushTime.ShowWindow( SW_HIDE );
			m_StcHIDCrLf.ShowWindow( SW_HIDE );
			m_CmbHIDPushTime.ShowWindow( SW_HIDE );
			m_CmbHIDCrLf.ShowWindow( SW_HIDE );

			// 1.03.021.04i
			if( _strnicmp( theApp.m_StrVersion.Mid( 9 ), "1.03.02", 7 ) == 0 )
			{
				m_StcHIDPushTime.ShowWindow( SW_SHOW );
				m_StcHIDCrLf.ShowWindow( SW_SHOW );
				m_CmbHIDPushTime.ShowWindow( SW_SHOW );
				m_CmbHIDCrLf.ShowWindow( SW_SHOW );
			}

			// Ver 1.3.0.0 HID
			if( m_StcHIDPushTime.IsWindowVisible()  )
			{
				cmbNum = sizeof HIDCrLf /sizeof HIDCrLf[0];
				for (i = 0; i < cmbNum; i++)
				{
					if(_strnicmp(HIDCrLf[i].KeyString+1, theApp.m_StrHIDCrLf, theApp.m_StrHIDCrLf.GetLength()-2 ) == 0)
					{
						m_HIDCrLfIndex = i;
						TRACE("OnInitDialog m_HIDCrLfIndex = %d\n", m_HIDCrLfIndex);
					}
					m_CmbHIDCrLf.InsertString(i, (LPCTSTR)HIDCrLf[i].KeyString);
				}

				for (i = 0; i < 10; i++)
				{
					strData.Format("%d", (i+1)*10 );
					if(_strnicmp(strData, theApp.m_StrHIDPushTime, strData.GetLength() ) == 0)
					{
						m_HIDPushTimeIndex = i;
						TRACE("OnInitDialog m_HIDPushTimeIndex = %d\n", m_HIDPushTimeIndex);
					}
					m_CmbHIDPushTime.InsertString(i, strData );
				}
			}
		}
		// Ver 1.3.0.0 HID (2024/05/14) t@[o[W"1.04"ȍ~
		else
		{
			m_StcHIDPushTime.ShowWindow( SW_SHOW );
			m_StcHIDCrLf.ShowWindow( SW_SHOW );
			m_CmbHIDPushTime.ShowWindow( SW_SHOW );
			m_CmbHIDCrLf.ShowWindow( SW_SHOW );

			cmbNum = sizeof HIDCrLf /sizeof HIDCrLf[0];
			for (i = 0; i < cmbNum; i++)
			{
				if(_strnicmp(HIDCrLf[i].KeyString+1, theApp.m_StrHIDCrLf, theApp.m_StrHIDCrLf.GetLength()-2 ) == 0)
				{
					m_HIDCrLfIndex = i;
					TRACE("OnInitDialog m_HIDCrLfIndex = %d\n", m_HIDCrLfIndex);
				}
				m_CmbHIDCrLf.InsertString(i, (LPCTSTR)HIDCrLf[i].KeyString);
			}

			for (i = 0; i < 10; i++)
			{
				strData.Format("%d", (i+1)*10 );
				if(_strnicmp(strData, theApp.m_StrHIDPushTime, strData.GetLength() ) == 0)
				{
					m_HIDPushTimeIndex = i;
					TRACE("OnInitDialog m_HIDPushTimeIndex = %d\n", m_HIDPushTimeIndex);
				}
				m_CmbHIDPushTime.InsertString(i, strData );
			}
		}
	}

	m_StrBtName = theApp.m_StrBtName;
	m_StrBtAddress = theApp.m_StrBtAddress;

	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

// ================================================================
//e
//  ݒ{^NbN̏
//
//	Ȃ
//߂l
//	Ȃ	
// ================================================================
void CConfigDlg::OnBnClickedConfig()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	int	nLen;

	if(_strnicmp(theApp.m_StrVersion, "Ver 4.77", 8 ) == 0)
	{
		if( ( m_CmbData.GetCurSel() == 0 ) &&
			( m_CmbParity.GetCurSel() == 0 ) &&
			( m_CmbStop.GetCurSel() == 0 ) )
		{
			MessageBox( TEXT("t@[EFAVer4.77ł\n[f[^rbg:7][peB:Ȃ][Xgbvrbg:1]\n̑gݍ킹͂gp܂B"), TEXT("BT62SettingSamp"), MB_OK);			
			return;
		}
	}

	nLen = sizeof(Baud[0].CmdString);

	if(m_BaudIndex != m_CmbBaud.GetCurSel())
	{
		TRACE("OnBnClickedConfig BaudIndex(%d) ---> (%d)\n", m_BaudIndex, m_CmbBaud.GetCurSel());
		memcpy(theApp.m_CmdItemString[theApp.m_CmdItemCount], Baud[m_CmbBaud.GetCurSel()].CmdString, nLen);
		theApp.m_CmdItemCount++;
	}
	if(m_DataIndex != m_CmbData.GetCurSel())
	{
		TRACE("OnBnClickedConfig m_DataIndex(%d) ---> (%d)\n", m_DataIndex, m_CmbData.GetCurSel());
		memcpy(theApp.m_CmdItemString[theApp.m_CmdItemCount], DataBit[m_CmbData.GetCurSel()].CmdString, nLen);
		TRACE("OnBnClickedConfig m_CmbData m_CmdItemString = %s\n", theApp.m_CmdItemString[theApp.m_CmdItemCount]);
		theApp.m_CmdItemCount++;
	}
	if(m_ParityIndex != m_CmbParity.GetCurSel())
	{
		TRACE("OnBnClickedConfig m_ParityIndex(%d) ---> (%d)\n", m_ParityIndex, m_CmbParity.GetCurSel());
		memcpy(theApp.m_CmdItemString[theApp.m_CmdItemCount], Parity[m_CmbParity.GetCurSel()].CmdString, nLen);
		TRACE("OnBnClickedConfig m_CmbParity m_CmdItemString = %s\n", theApp.m_CmdItemString[theApp.m_CmdItemCount]);
		theApp.m_CmdItemCount++;
	}
	if(m_StopIndex != m_CmbStop.GetCurSel())
	{
		TRACE("OnBnClickedConfig m_StopIndex(%d) ---> (%d)\n", m_StopIndex, m_CmbStop.GetCurSel());
		memcpy(theApp.m_CmdItemString[theApp.m_CmdItemCount], StopBit[m_CmbStop.GetCurSel()].CmdString, nLen);
		TRACE("OnBnClickedConfig m_CmbStop m_CmdItemString = %s\n", theApp.m_CmdItemString[theApp.m_CmdItemCount]);
		theApp.m_CmdItemCount++;
	}

	// Ver 1.2.0.0 "BT62 Ver."ȍ~̊mFĔFؕ
	if( _strnicmp( theApp.m_StrVersion.Mid( 9 ), "1.00", 4 ) == 0 )
	{
		m_CmbAuth.ShowWindow( SW_HIDE );
		m_StcAuth.ShowWindow( SW_HIDE );

		m_EdtPINCode.ShowWindow( SW_HIDE );
		m_StcPINCode.ShowWindow( SW_HIDE );

		// Ver 1.3.0.0 HID[h
		m_StcHIDPushTime.ShowWindow( SW_HIDE );
		m_StcHIDCrLf.ShowWindow( SW_HIDE );
		m_CmbHIDPushTime.ShowWindow( SW_HIDE );
		m_CmbHIDCrLf.ShowWindow( SW_HIDE );
	}
	else if( _strnicmp( theApp.m_StrVersion.Mid( 9 ), "1.01", 4 ) == 0 )
	{
		m_CmbAuth.ShowWindow( SW_HIDE );
		m_StcAuth.ShowWindow( SW_HIDE );

		m_EdtPINCode.ShowWindow( SW_HIDE );
		m_StcPINCode.ShowWindow( SW_HIDE );

		// Ver 1.3.0.0 HID[h
		m_StcHIDPushTime.ShowWindow( SW_HIDE );
		m_StcHIDCrLf.ShowWindow( SW_HIDE );
		m_CmbHIDPushTime.ShowWindow( SW_HIDE );
		m_CmbHIDCrLf.ShowWindow( SW_HIDE );
	}
	else
	{
		m_CmbAuth.ShowWindow( SW_SHOW );
		m_StcAuth.ShowWindow( SW_SHOW );
		// Ver 1.1.0.0 ǉ
		if(m_AuthIndex != m_CmbAuth.GetCurSel())
		{
			TRACE("OnBnClickedConfig m_AuthIndex(%d) ---> (%d)\n", m_AuthIndex, m_CmbAuth.GetCurSel());
			memcpy(theApp.m_CmdItemString[theApp.m_CmdItemCount], Authen[m_CmbAuth.GetCurSel()].CmdString, nLen);
			TRACE("OnBnClickedConfig m_CmbAuth m_CmdItemString = %s\n", theApp.m_CmdItemString[theApp.m_CmdItemCount]);
			theApp.m_CmdItemCount++;
		}

		// Ver 1.3.0.0 HID[h
		if( _strnicmp( theApp.m_StrVersion.Mid( 9 ), "1.02", 4 ) == 0 )
		{
			m_StcHIDPushTime.ShowWindow( SW_HIDE );
			m_StcHIDCrLf.ShowWindow( SW_HIDE );
			m_CmbHIDPushTime.ShowWindow( SW_HIDE );
			m_CmbHIDCrLf.ShowWindow( SW_HIDE );
		}
		else if( _strnicmp( theApp.m_StrVersion.Mid( 9 ), "1.03", 4 ) == 0 )
		{
			m_StcHIDPushTime.ShowWindow( SW_HIDE );
			m_StcHIDCrLf.ShowWindow( SW_HIDE );
			m_CmbHIDPushTime.ShowWindow( SW_HIDE );
			m_CmbHIDCrLf.ShowWindow( SW_HIDE );

			// 1.03.021.04i
			if( _strnicmp( theApp.m_StrVersion.Mid( 9 ), "1.03.02", 7 ) == 0 )
			{
				m_StcHIDPushTime.ShowWindow( SW_SHOW );
				m_StcHIDCrLf.ShowWindow( SW_SHOW );
				m_CmbHIDPushTime.ShowWindow( SW_SHOW );
				m_CmbHIDCrLf.ShowWindow( SW_SHOW );
			}
		}
		// Ver 1.3.0.0 HID (2024/05/14) t@[o[W"1.04"ȍ~
		else
		{
			m_StcHIDPushTime.ShowWindow( SW_SHOW );
			m_StcHIDCrLf.ShowWindow( SW_SHOW );
			m_CmbHIDPushTime.ShowWindow( SW_SHOW );
			m_CmbHIDCrLf.ShowWindow( SW_SHOW );
		}
	}

	UpdateData(TRUE);

	// Ver 1.2.0.0 "BT62 Ver."ȍ~̊mFĔFؕ
	if( _strnicmp( theApp.m_StrVersion.Mid( 9 ), "1.00", 4 ) == 0 )
	{
		m_CmbAuth.ShowWindow( SW_HIDE );
		m_StcAuth.ShowWindow( SW_HIDE );

		m_EdtPINCode.ShowWindow( SW_HIDE );
		m_StcPINCode.ShowWindow( SW_HIDE );

		// Ver 1.3.0.0 HID[h
		m_StcHIDPushTime.ShowWindow( SW_HIDE );
		m_StcHIDCrLf.ShowWindow( SW_HIDE );
		m_CmbHIDPushTime.ShowWindow( SW_HIDE );
		m_CmbHIDCrLf.ShowWindow( SW_HIDE );
	}
	else if( _strnicmp( theApp.m_StrVersion.Mid( 9 ), "1.01", 4 ) == 0 )
	{
		m_CmbAuth.ShowWindow( SW_HIDE );
		m_StcAuth.ShowWindow( SW_HIDE );

		m_EdtPINCode.ShowWindow( SW_HIDE );
		m_StcPINCode.ShowWindow( SW_HIDE );

		// Ver 1.3.0.0 HID[h
		m_StcHIDPushTime.ShowWindow( SW_HIDE );
		m_StcHIDCrLf.ShowWindow( SW_HIDE );
		m_CmbHIDPushTime.ShowWindow( SW_HIDE );
		m_CmbHIDCrLf.ShowWindow( SW_HIDE );
	}
	else
	{
		m_CmbAuth.ShowWindow( SW_SHOW );
		m_StcAuth.ShowWindow( SW_SHOW );
		// Ver 1.1.0.0 ǉ
		// PINF
		if(m_AuthIndex == 2)
		{
			if( m_StrPINCode.GetLength() == 0 )
			{
				MessageBox( TEXT("PINR[hw肵Ă"), TEXT("BT62SettingSamp"), MB_OK);
				return;
			}

			if( m_StrPINCode.GetLength() > 16 )
			{
				MessageBox( TEXT("PINR[h͍ő16łB"), TEXT("BT62SettingSamp"), MB_OK);
				return;
			}

			sprintf_s(theApp.m_CmdItemString[theApp.m_CmdItemCount], nLen, "SP,%s\r\n", m_StrPINCode);
			TRACE("OnBnClickedConfig m_ChkBtName m_CmdItemString = %s\n", theApp.m_CmdItemString[theApp.m_CmdItemCount]);
			theApp.m_CmdItemCount++;
		}

		// Ver 1.3.0.0 HID[h
		if( _strnicmp( theApp.m_StrVersion.Mid( 9 ), "1.02", 4 ) == 0 )
		{
			m_StcHIDPushTime.ShowWindow( SW_HIDE );
			m_StcHIDCrLf.ShowWindow( SW_HIDE );
			m_CmbHIDPushTime.ShowWindow( SW_HIDE );
			m_CmbHIDCrLf.ShowWindow( SW_HIDE );
		}
		else if( _strnicmp( theApp.m_StrVersion.Mid( 9 ), "1.03", 4 ) == 0 )
		{
			m_StcHIDPushTime.ShowWindow( SW_HIDE );
			m_StcHIDCrLf.ShowWindow( SW_HIDE );
			m_CmbHIDPushTime.ShowWindow( SW_HIDE );
			m_CmbHIDCrLf.ShowWindow( SW_HIDE );

			// 1.03.021.04i
			if( _strnicmp( theApp.m_StrVersion.Mid( 9 ), "1.03.02", 7 ) == 0 )
			{
				m_StcHIDPushTime.ShowWindow( SW_SHOW );
				m_StcHIDCrLf.ShowWindow( SW_SHOW );
				m_CmbHIDPushTime.ShowWindow( SW_SHOW );
				m_CmbHIDCrLf.ShowWindow( SW_SHOW );
			}
		}
		// Ver 1.3.0.0 HID (2024/05/14) t@[o[W"1.04"ȍ~
		else
		{
			m_StcHIDPushTime.ShowWindow( SW_SHOW );
			m_StcHIDCrLf.ShowWindow( SW_SHOW );
			m_CmbHIDPushTime.ShowWindow( SW_SHOW );
			m_CmbHIDCrLf.ShowWindow( SW_SHOW );
		}
	}

	// Ver 1.3.0.0 HID[h
	if( m_StcHIDPushTime.IsWindowVisible()  )
	{
		// m_StcHIDPushTime\

		TRACE("OnBnClickedConfig HIDCrLfIndex(%d) ---> (%d)\n", m_HIDCrLfIndex, m_CmbHIDCrLf.GetCurSel());
		memcpy(theApp.m_CmdItemString[theApp.m_CmdItemCount], HIDCrLf[m_CmbHIDCrLf.GetCurSel()].CmdString, nLen);
		theApp.m_CmdItemCount++;

		// Ver 1.4.0.0 C
		//sprintf_s(theApp.m_CmdItemString[theApp.m_CmdItemCount], nLen, "SY,%s\r\n", m_StrHIDPushTime);
		//TRACE("OnBnClickedConfig HIDPushTime m_CmdItemString = %s\n", theApp.m_CmdItemString[theApp.m_CmdItemCount]);
		m_StrHIDPushTime.Format("%d", ( m_CmbHIDPushTime.GetCurSel() + 1 )*10 );
		TRACE("OnBnClickedConfig HIDPushTime(%d) ---> (%d)\n", m_HIDPushTimeIndex, m_CmbHIDPushTime.GetCurSel());
		sprintf_s(theApp.m_CmdItemString[theApp.m_CmdItemCount], nLen, "SY,%s\r\n", m_StrHIDPushTime);
		theApp.m_CmdItemCount++;
	}


	if( m_StrBtName.GetLength() == 0 )
	{
		MessageBox( TEXT("foCXw肵ĂB"), TEXT("BT62SettingSamp"), MB_OK);
		return;
	}

	if( m_StrBtName.GetLength() > 20 )
	{
		MessageBox( TEXT("foCX͍ő20łB"), TEXT("BT62SettingSamp"), MB_OK);
		return;
	}

	if(m_ChkBtName.GetCheck())
	{
		sprintf_s(theApp.m_CmdItemString[theApp.m_CmdItemCount], nLen, "SN,%s\r\n", m_StrBtName);
		TRACE("OnBnClickedConfig m_ChkBtName m_CmdItemString = %s\n", theApp.m_CmdItemString[theApp.m_CmdItemCount]);
		theApp.m_CmdItemCount++;
	}

	sprintf_s(theApp.m_CmdItemString[theApp.m_CmdItemCount], nLen, "R,1\r\n");
	TRACE("OnBnClickedDefault m_CmdItemString = %s\n", theApp.m_CmdItemString[theApp.m_CmdItemCount]);
	theApp.m_CmdItemCount++;

	OnOK();
}

// ================================================================
//e
//  ftHg{^NbN̏
//
//	Ȃ
//߂l
//	Ȃ	
// ================================================================
void CConfigDlg::OnBnClickedDefault()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	CString r4String;
	int	nLen;

	nLen = sizeof(Baud[0].CmdString);

	if(m_StrBtAddress.GetLength() == 12)
	{
		//Ō (E[)w蕶o
		r4String = m_StrBtAddress.Right(4);
		m_StrBtName.Format("RN42-%s", r4String);

		sprintf_s(theApp.m_CmdItemString[theApp.m_CmdItemCount], nLen, "SN,%s\r\n", m_StrBtName);
		TRACE("OnBnClickedConfig m_ChkBtName m_CmdItemString = %s\n", theApp.m_CmdItemString[theApp.m_CmdItemCount]);
		theApp.m_CmdItemCount++;
	}


	sprintf_s(theApp.m_CmdItemString[theApp.m_CmdItemCount], nLen, "SF,1\r\n");
	TRACE("OnBnClickedDefault m_CmdItemString = %s\n", theApp.m_CmdItemString[theApp.m_CmdItemCount]);
	theApp.m_CmdItemCount++;

	fDefault = TRUE;

	OnOK();
}


// ================================================================
//e
//  `FbN{^(foCX)NbN̏
//
//	Ȃ
//߂l
//	Ȃ	
// ================================================================
void CConfigDlg::OnBnClickedCheck2()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	if(m_ChkBtName.GetCheck())
	{
		m_EdtBtName.EnableWindow(TRUE);
	}
	else
	{
		m_EdtBtName.EnableWindow(FALSE);
	}
}


void CConfigDlg::OnCbnSelchangeCombo6()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	if( m_CmbAuth.GetCurSel() == 2 )
	{
		m_EdtPINCode.ShowWindow( SW_SHOW );
		m_StcPINCode.ShowWindow( SW_SHOW );
	}
	else
	{
		m_EdtPINCode.ShowWindow( SW_HIDE );
		m_StcPINCode.ShowWindow( SW_HIDE );
	}
}
